﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Reflection;

namespace howto_get_field_by_name
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Some form-level values.
        private string private_value1 = "This is private value 1";
        private string private_value2 = "This is private value 2";
        public string public_value1 = "This is public string value 1";
        public string public_value2 = "This is public string value 2";
        public string[] array1 = { "A", "B", "C" };
        public string[] array2 = { "1", "2", "3" };

        // Display the selected field's value.
        private void cboFields_SelectedIndexChanged(object sender, EventArgs e)
        {
            FieldInfo field_info = this.GetType().GetField(cboFields.Text,
                BindingFlags.Instance | BindingFlags.NonPublic | BindingFlags.Public);
            if (field_info == null)
            {
                lblValue.Text = "<not found>";
            }
            else if (field_info.FieldType.IsArray)
            {
                // Join the array values into a string.
                string[] values = (string[])field_info.GetValue(this);
                lblValue.Text = string.Join(",", values);
            }
            else
            {
                // Just convert it into a string.
                lblValue.Text = field_info.GetValue(this).ToString();
            }
        }
    }
}
